package org.jeecg.modules.fbsWarehouse.controller;

import java.util.Arrays;
import java.util.List;
import java.util.Map;
import java.io.IOException;
import java.io.UnsupportedEncodingException;
import java.net.URLDecoder;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;

import org.apache.commons.lang.StringUtils;
import org.jeecg.common.api.vo.Result;
import org.jeecg.common.system.query.QueryGenerator;
import org.jeecg.common.util.oConvertUtils;
import org.jeecg.modules.fbsWarehouse.entity.FbsWarehouse;
import org.jeecg.modules.fbsWarehouse.service.IFbsWarehouseService;

import com.baomidou.mybatisplus.core.conditions.query.QueryWrapper;
import com.baomidou.mybatisplus.core.metadata.IPage;
import com.baomidou.mybatisplus.extension.plugins.pagination.Page;
import lombok.extern.slf4j.Slf4j;

import org.jeecgframework.poi.excel.ExcelImportUtil;
import org.jeecgframework.poi.excel.def.NormalExcelConstants;
import org.jeecgframework.poi.excel.entity.ExportParams;
import org.jeecgframework.poi.excel.entity.ImportParams;
import org.jeecgframework.poi.excel.view.JeecgEntityExcelView;

import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.*;
import org.springframework.web.multipart.MultipartFile;
import org.springframework.web.multipart.MultipartHttpServletRequest;
import org.springframework.web.servlet.ModelAndView;
import com.alibaba.fastjson.JSON;

 /**
 * @Title: Controller
 * @Description: 仓库报表
 * @author： jeecg-boot
 * @date：   2021-01-20
 * @version： V1.0
 */
@RestController
@RequestMapping("/fbsWarehouse/fbsWarehouse")
@Slf4j
public class FbsWarehouseController {
	@Autowired
	private IFbsWarehouseService fbsWarehouseService;
	
	/**
	  * 分页列表查询
	 * @param fbsWarehouse
	 * @param pageNo
	 * @param pageSize
	 * @param req
	 * @return
	 */
	@GetMapping(value = "/list")
	public Result<IPage<FbsWarehouse>> queryPageList(FbsWarehouse fbsWarehouse,
									  @RequestParam(name="pageNo", defaultValue="1") Integer pageNo,
									  @RequestParam(name="pageSize", defaultValue="10") Integer pageSize,
									  HttpServletRequest req) {
		Result<IPage<FbsWarehouse>> result = new Result<IPage<FbsWarehouse>>();
		String start=fbsWarehouse.getStart();
		String end=fbsWarehouse.getEnd();
		if(StringUtils.isNotBlank(start)){
			fbsWarehouse.setStart(null);
		}
		if(StringUtils.isNotBlank(end)){
			fbsWarehouse.setEnd(null);
		}
		QueryWrapper<FbsWarehouse> queryWrapper = QueryGenerator.initQueryWrapper(fbsWarehouse, req.getParameterMap());
		queryWrapper.lambda().eq(FbsWarehouse::getDelFlag,"0");
		queryWrapper.lambda().orderByDesc(FbsWarehouse::getCreateTime);
		if(StringUtils.isNotBlank(start)&&StringUtils.isNotBlank(end)&&!start.equals("null")&&!end.equals("null")){
			queryWrapper.ge("DATE_FORMAT(date,'%Y-%m-%d')",start);
			queryWrapper.le("DATE_FORMAT(date,'%Y-%m-%d')",end);
		}else{
			queryWrapper.apply("DATE_FORMAT( date, '%Y%m' ) = DATE_FORMAT( CURDATE( ) , '%Y%m' )");
		}
		Page<FbsWarehouse> page = new Page<FbsWarehouse>(pageNo, pageSize);
		IPage<FbsWarehouse> pageList = fbsWarehouseService.page(page, queryWrapper);
		result.setSuccess(true);
		result.setResult(pageList);
		return result;
	}
	
	/**
	  *   添加
	 * @param fbsWarehouse
	 * @return
	 */
	@PostMapping(value = "/add")
	public Result<FbsWarehouse> add(@RequestBody FbsWarehouse fbsWarehouse) {
		Result<FbsWarehouse> result = new Result<FbsWarehouse>();
		try {
			fbsWarehouseService.save(fbsWarehouse);
			result.success("添加成功！");
		} catch (Exception e) {
			e.printStackTrace();
			log.info(e.getMessage());
			result.error500("操作失败");
		}
		return result;
	}
	
	/**
	  *  编辑
	 * @param fbsWarehouse
	 * @return
	 */
	@PutMapping(value = "/edit")
	public Result<FbsWarehouse> edit(@RequestBody FbsWarehouse fbsWarehouse) {
		Result<FbsWarehouse> result = new Result<FbsWarehouse>();
		FbsWarehouse fbsWarehouseEntity = fbsWarehouseService.getById(fbsWarehouse.getId());
		if(fbsWarehouseEntity==null) {
			result.error500("未找到对应实体");
		}else {
			boolean ok = fbsWarehouseService.updateById(fbsWarehouse);
			//TODO 返回false说明什么？
			if(ok) {
				result.success("修改成功!");
			}
		}
		
		return result;
	}
	
	/**
	  *   通过id删除
	 * @param id
	 * @return
	 */
	@DeleteMapping(value = "/delete")
	public Result<FbsWarehouse> delete(@RequestParam(name="id",required=true) String id) {
		Result<FbsWarehouse> result = new Result<FbsWarehouse>();
		FbsWarehouse fbsWarehouse = fbsWarehouseService.getById(id);
		if(fbsWarehouse==null) {
			result.error500("未找到对应实体");
		}else {
			boolean ok = fbsWarehouseService.removeById(id);
			if(ok) {
				result.success("删除成功!");
			}
		}
		
		return result;
	}

	 /**
	  *   通过id删除
	  * @param id
	  * @return
	  */
	 @DeleteMapping(value = "/deleteD")
	 public Result<FbsWarehouse> deleteD(@RequestParam(name="id",required=true) String id) {
		 Result<FbsWarehouse> result = new Result<FbsWarehouse>();
		 FbsWarehouse fbsWarehouse = fbsWarehouseService.getById(id);
		 if(fbsWarehouse==null) {
			 result.error500("未找到对应实体");
		 }else {
//			 boolean ok = fbsWarehouseService.removeById(id);
			 fbsWarehouse.setDelFlag("1");
			 boolean ok = fbsWarehouseService.updateById(fbsWarehouse);
			 if(ok) {
				 result.success("删除成功!");
			 }
		 }

		 return result;
	 }
	
	/**
	  *  批量删除
	 * @param ids
	 * @return
	 */
	@DeleteMapping(value = "/deleteBatch")
	public Result<FbsWarehouse> deleteBatch(@RequestParam(name="ids",required=true) String ids) {
		Result<FbsWarehouse> result = new Result<FbsWarehouse>();
		if(ids==null || "".equals(ids.trim())) {
			result.error500("参数不识别！");
		}else {
			this.fbsWarehouseService.removeByIds(Arrays.asList(ids.split(",")));
			result.success("删除成功!");
		}
		return result;
	}
	
	/**
	  * 通过id查询
	 * @param id
	 * @return
	 */
	@GetMapping(value = "/queryById")
	public Result<FbsWarehouse> queryById(@RequestParam(name="id",required=true) String id) {
		Result<FbsWarehouse> result = new Result<FbsWarehouse>();
		FbsWarehouse fbsWarehouse = fbsWarehouseService.getById(id);
		if(fbsWarehouse==null) {
			result.error500("未找到对应实体");
		}else {
			result.setResult(fbsWarehouse);
			result.setSuccess(true);
		}
		return result;
	}

  /**
      * 导出excel
   *
   * @param request
   * @param response
   */
  @RequestMapping(value = "/exportXls")
  public ModelAndView exportXls(HttpServletRequest request, HttpServletResponse response) {
      // Step.1 组装查询条件
      QueryWrapper<FbsWarehouse> queryWrapper = null;
      try {
          String paramsStr = request.getParameter("paramsStr");
          if (oConvertUtils.isNotEmpty(paramsStr)) {
              String deString = URLDecoder.decode(paramsStr, "UTF-8");
              FbsWarehouse fbsWarehouse = JSON.parseObject(deString, FbsWarehouse.class);
              queryWrapper = QueryGenerator.initQueryWrapper(fbsWarehouse, request.getParameterMap());
          }
      } catch (UnsupportedEncodingException e) {
          e.printStackTrace();
      }

      //Step.2 AutoPoi 导出Excel
      ModelAndView mv = new ModelAndView(new JeecgEntityExcelView());
      List<FbsWarehouse> pageList = fbsWarehouseService.list(queryWrapper);
      //导出文件名称
      mv.addObject(NormalExcelConstants.FILE_NAME, "仓库报表列表");
      mv.addObject(NormalExcelConstants.CLASS, FbsWarehouse.class);
      mv.addObject(NormalExcelConstants.PARAMS, new ExportParams("仓库报表列表数据", "导出人:Jeecg", "导出信息"));
      mv.addObject(NormalExcelConstants.DATA_LIST, pageList);
      return mv;
  }

  /**
      * 通过excel导入数据
   *
   * @param request
   * @param response
   * @return
   */
  @RequestMapping(value = "/importExcel", method = RequestMethod.POST)
  public Result<?> importExcel(HttpServletRequest request, HttpServletResponse response) {
      MultipartHttpServletRequest multipartRequest = (MultipartHttpServletRequest) request;
      Map<String, MultipartFile> fileMap = multipartRequest.getFileMap();
      for (Map.Entry<String, MultipartFile> entity : fileMap.entrySet()) {
          MultipartFile file = entity.getValue();// 获取上传文件对象
          ImportParams params = new ImportParams();
          params.setTitleRows(2);
          params.setHeadRows(1);
          params.setNeedSave(true);
          try {
              List<FbsWarehouse> listFbsWarehouses = ExcelImportUtil.importExcel(file.getInputStream(), FbsWarehouse.class, params);
              for (FbsWarehouse fbsWarehouseExcel : listFbsWarehouses) {
                  fbsWarehouseService.save(fbsWarehouseExcel);
              }
              return Result.ok("文件导入成功！数据行数：" + listFbsWarehouses.size());
          } catch (Exception e) {
              log.error(e.getMessage());
              return Result.error("文件导入失败！");
          } finally {
              try {
                  file.getInputStream().close();
              } catch (IOException e) {
                  e.printStackTrace();
              }
          }
      }
      return Result.ok("文件导入失败！");
  }

}
